Show / Hide Table of Contents

# Class imnodes

##### Inheritance

System.Object
imnodes

##### Inherited Members

System.Object.Equals(System.Object)
System.Object.Equals(System.Object, System.Object)
System.Object.GetHashCode()
System.Object.GetType()
System.Object.MemberwiseClone()
System.Object.ReferenceEquals(System.Object, System.Object)
System.Object.ToString()

###### Namespace: imnodesNET

###### Assembly: ImGui.NET.dll

##### Syntax

    public static class imnodes

### Methods

| Improve this Doc View Source

#### BeginInputAttribute(Int32)

##### Declaration

    public static void BeginInputAttribute(int id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | id |

| Improve this Doc View Source

#### BeginInputAttribute(Int32, PinShape)

##### Declaration

    public static void BeginInputAttribute(int id, PinShape shape)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | id |
PinShape | shape |

| Improve this Doc View Source

#### BeginNode(Int32)

##### Declaration

    public static void BeginNode(int id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | id |

| Improve this Doc View Source

#### BeginNodeEditor()

##### Declaration

    public static void BeginNodeEditor()

| Improve this Doc View Source

#### BeginNodeTitleBar()

##### Declaration

    public static void BeginNodeTitleBar()

| Improve this Doc View Source

#### BeginOutputAttribute(Int32)

##### Declaration

    public static void BeginOutputAttribute(int id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | id |

| Improve this Doc View Source

#### BeginOutputAttribute(Int32, PinShape)

##### Declaration

    public static void BeginOutputAttribute(int id, PinShape shape)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | id |
PinShape | shape |

| Improve this Doc View Source

#### BeginStaticAttribute(Int32)

##### Declaration

    public static void BeginStaticAttribute(int id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | id |

| Improve this Doc View Source

#### ClearLinkSelection()

##### Declaration

    public static void ClearLinkSelection()

| Improve this Doc View Source

#### ClearNodeSelection()

##### Declaration

    public static void ClearNodeSelection()

| Improve this Doc View Source

#### EditorContextCreate()

##### Declaration

    public static IntPtr EditorContextCreate()

##### Returns

Type | Description
--- | ---
System.IntPtr |

| Improve this Doc View Source

#### EditorContextFree(IntPtr)

##### Declaration

    public static void EditorContextFree(IntPtr noname1)

##### Parameters

Type | Name | Description
--- | --- | ---
System.IntPtr | noname1 |

| Improve this Doc View Source

#### EditorContextGetPanning()

##### Declaration

    public static Vector2 EditorContextGetPanning()

##### Returns

Type | Description
--- | ---
System.Numerics.Vector2 |

| Improve this Doc View Source

#### EditorContextMoveToNode(Int32)

##### Declaration

    public static void EditorContextMoveToNode(int node_id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | node_id |

| Improve this Doc View Source

#### EditorContextResetPanning(Vector2)

##### Declaration

    public static void EditorContextResetPanning(Vector2 pos)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Numerics.Vector2 | pos |

| Improve this Doc View Source

#### EditorContextSet(IntPtr)

##### Declaration

    public static void EditorContextSet(IntPtr noname1)

##### Parameters

Type | Name | Description
--- | --- | ---
System.IntPtr | noname1 |

| Improve this Doc View Source

#### EndInputAttribute()

##### Declaration

    public static void EndInputAttribute()

| Improve this Doc View Source

#### EndNode()

##### Declaration

    public static void EndNode()

| Improve this Doc View Source

#### EndNodeEditor()

##### Declaration

    public static void EndNodeEditor()

| Improve this Doc View Source

#### EndNodeTitleBar()

##### Declaration

    public static void EndNodeTitleBar()

| Improve this Doc View Source

#### EndOutputAttribute()

##### Declaration

    public static void EndOutputAttribute()

| Improve this Doc View Source

#### EndStaticAttribute()

##### Declaration

    public static void EndStaticAttribute()

| Improve this Doc View Source

#### GetIO()

##### Declaration

    public static IO*GetIO()

##### Returns

Type | Description
--- | ---
IO* |

| Improve this Doc View Source

#### GetNodeDimensions(Int32)

##### Declaration

    public static Vector2 GetNodeDimensions(int id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | id |

##### Returns

Type | Description
--- | ---
System.Numerics.Vector2 |

| Improve this Doc View Source

#### GetNodeEditorSpacePos(Int32)

##### Declaration

    public static Vector2 GetNodeEditorSpacePos(int node_id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | node_id |

##### Returns

Type | Description
--- | ---
System.Numerics.Vector2 |

| Improve this Doc View Source

#### GetNodeGridSpacePos(Int32)

##### Declaration

    public static Vector2 GetNodeGridSpacePos(int node_id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | node_id |

##### Returns

Type | Description
--- | ---
System.Numerics.Vector2 |

| Improve this Doc View Source

#### GetNodeScreenSpacePos(Int32)

##### Declaration

    public static Vector2 GetNodeScreenSpacePos(int node_id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | node_id |

##### Returns

Type | Description
--- | ---
System.Numerics.Vector2 |

| Improve this Doc View Source

#### GetSelectedLinks(ref Int32)

##### Declaration

    public static void GetSelectedLinks(ref int link_ids)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | link_ids |

| Improve this Doc View Source

#### GetSelectedNodes(ref Int32)

##### Declaration

    public static void GetSelectedNodes(ref int node_ids)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | node_ids |

| Improve this Doc View Source

#### GetStyle()

##### Declaration

    public static Style*GetStyle()

##### Returns

Type | Description
--- | ---
Style* |

| Improve this Doc View Source

#### Initialize()

##### Declaration

    public static void Initialize()

| Improve this Doc View Source

#### IsAnyAttributeActive()

##### Declaration

    public static bool IsAnyAttributeActive()

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsAnyAttributeActive(ref Int32)

##### Declaration

    public static bool IsAnyAttributeActive(ref int attribute_id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | attribute_id |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsAttributeActive()

##### Declaration

    public static bool IsAttributeActive()

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsEditorHovered()

##### Declaration

    public static bool IsEditorHovered()

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsLinkCreated(ref Int32, ref Int32)

##### Declaration

    public static bool IsLinkCreated(ref int started_at_attribute_id, ref int ended_at_attribute_id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | started_at_attribute_id |
System.Int32 | ended_at_attribute_id |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsLinkCreated(ref Int32, ref Int32, ref Boolean)

##### Declaration

    public static bool IsLinkCreated(ref int started_at_attribute_id, ref int ended_at_attribute_id, ref bool created_from_snap)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | started_at_attribute_id |
System.Int32 | ended_at_attribute_id |
System.Boolean | created_from_snap |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsLinkCreated(ref Int32, ref Int32, ref Int32, ref Int32)

##### Declaration

    public static bool IsLinkCreated(ref int started_at_node_id, ref int started_at_attribute_id, ref int ended_at_node_id, ref int ended_at_attribute_id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | started_at_node_id |
System.Int32 | started_at_attribute_id |
System.Int32 | ended_at_node_id |
System.Int32 | ended_at_attribute_id |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsLinkCreated(ref Int32, ref Int32, ref Int32, ref Int32, ref Boolean)

##### Declaration

    public static bool IsLinkCreated(ref int started_at_node_id, ref int started_at_attribute_id, ref int ended_at_node_id, ref int ended_at_attribute_id, ref bool created_from_snap)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | started_at_node_id |
System.Int32 | started_at_attribute_id |
System.Int32 | ended_at_node_id |
System.Int32 | ended_at_attribute_id |
System.Boolean | created_from_snap |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsLinkDestroyed(ref Int32)

##### Declaration

    public static bool IsLinkDestroyed(ref int link_id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | link_id |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsLinkDropped()

##### Declaration

    public static bool IsLinkDropped()

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsLinkDropped(ref Int32)

##### Declaration

    public static bool IsLinkDropped(ref int started_at_attribute_id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | started_at_attribute_id |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsLinkDropped(ref Int32, Boolean)

##### Declaration

    public static bool IsLinkDropped(ref int started_at_attribute_id, bool including_detached_links)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | started_at_attribute_id |
System.Boolean | including_detached_links |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsLinkHovered(ref Int32)

##### Declaration

    public static bool IsLinkHovered(ref int link_id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | link_id |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsLinkStarted(ref Int32)

##### Declaration

    public static bool IsLinkStarted(ref int started_at_attribute_id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | started_at_attribute_id |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsNodeHovered(ref Int32)

##### Declaration

    public static bool IsNodeHovered(ref int node_id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | node_id |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### IsPinHovered(ref Int32)

##### Declaration

    public static bool IsPinHovered(ref int attribute_id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | attribute_id |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Link(Int32, Int32, Int32)

##### Declaration

    public static void Link(int id, int start_attribute_id, int end_attribute_id)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | id |
System.Int32 | start_attribute_id |
System.Int32 | end_attribute_id |

| Improve this Doc View Source

#### LoadCurrentEditorStateFromIniFile(String)

##### Declaration

    public static void LoadCurrentEditorStateFromIniFile(string file_name)

##### Parameters

Type | Name | Description
--- | --- | ---
System.String | file_name |

| Improve this Doc View Source

#### LoadCurrentEditorStateFromIniString(String, UInt32)

##### Declaration

    public static void LoadCurrentEditorStateFromIniString(string data, uint data_size)

##### Parameters

Type | Name | Description
--- | --- | ---
System.String | data |
System.UInt32 | data_size |

| Improve this Doc View Source

#### LoadEditorStateFromIniFile(IntPtr, String)

##### Declaration

    public static void LoadEditorStateFromIniFile(IntPtr editor, string file_name)

##### Parameters

Type | Name | Description
--- | --- | ---
System.IntPtr | editor |
System.String | file_name |

| Improve this Doc View Source

#### LoadEditorStateFromIniString(IntPtr, String, UInt32)

##### Declaration

    public static void LoadEditorStateFromIniString(IntPtr editor, string data, uint data_size)

##### Parameters

Type | Name | Description
--- | --- | ---
System.IntPtr | editor |
System.String | data |
System.UInt32 | data_size |

| Improve this Doc View Source

#### NumSelectedLinks()

##### Declaration

    public static int NumSelectedLinks()

##### Returns

Type | Description
--- | ---
System.Int32 |

| Improve this Doc View Source

#### NumSelectedNodes()

##### Declaration

    public static int NumSelectedNodes()

##### Returns

Type | Description
--- | ---
System.Int32 |

| Improve this Doc View Source

#### PopAttributeFlag()

##### Declaration

    public static void PopAttributeFlag()

| Improve this Doc View Source

#### PopColorStyle()

##### Declaration

    public static void PopColorStyle()

| Improve this Doc View Source

#### PopStyleVar()

##### Declaration

    public static void PopStyleVar()

| Improve this Doc View Source

#### PushAttributeFlag(AttributeFlags)

##### Declaration

    public static void PushAttributeFlag(AttributeFlags flag)

##### Parameters

Type | Name | Description
--- | --- | ---
AttributeFlags | flag |

| Improve this Doc View Source

#### PushColorStyle(ColorStyle, UInt32)

##### Declaration

    public static void PushColorStyle(ColorStyle item, uint color)

##### Parameters

Type | Name | Description
--- | --- | ---
ColorStyle | item |
System.UInt32 | color |

| Improve this Doc View Source

#### PushStyleVar(StyleVar, Single)

##### Declaration

    public static void PushStyleVar(StyleVar style_item, float value)

##### Parameters

Type | Name | Description
--- | --- | ---
StyleVar | style_item |
System.Single | value |

| Improve this Doc View Source

#### SaveCurrentEditorStateToIniFile(String)

##### Declaration

    public static void SaveCurrentEditorStateToIniFile(string file_name)

##### Parameters

Type | Name | Description
--- | --- | ---
System.String | file_name |

| Improve this Doc View Source

#### SaveCurrentEditorStateToIniString()

##### Declaration

    public static string SaveCurrentEditorStateToIniString()

##### Returns

Type | Description
--- | ---
System.String |

| Improve this Doc View Source

#### SaveCurrentEditorStateToIniString(ref UInt32)

##### Declaration

    public static string SaveCurrentEditorStateToIniString(ref uint data_size)

##### Parameters

Type | Name | Description
--- | --- | ---
System.UInt32 | data_size |

##### Returns

Type | Description
--- | ---
System.String |

| Improve this Doc View Source

#### SaveEditorStateToIniFile(IntPtr, String)

##### Declaration

    public static void SaveEditorStateToIniFile(IntPtr editor, string file_name)

##### Parameters

Type | Name | Description
--- | --- | ---
System.IntPtr | editor |
System.String | file_name |

| Improve this Doc View Source

#### SaveEditorStateToIniString(IntPtr)

##### Declaration

    public static string SaveEditorStateToIniString(IntPtr editor)

##### Parameters

Type | Name | Description
--- | --- | ---
System.IntPtr | editor |

##### Returns

Type | Description
--- | ---
System.String |

| Improve this Doc View Source

#### SaveEditorStateToIniString(IntPtr, ref UInt32)

##### Declaration

    public static string SaveEditorStateToIniString(IntPtr editor, ref uint data_size)

##### Parameters

Type | Name | Description
--- | --- | ---
System.IntPtr | editor |
System.UInt32 | data_size |

##### Returns

Type | Description
--- | ---
System.String |

| Improve this Doc View Source

#### SetImGuiContext(IntPtr)

##### Declaration

    public static void SetImGuiContext(IntPtr ctx)

##### Parameters

Type | Name | Description
--- | --- | ---
System.IntPtr | ctx |

| Improve this Doc View Source

#### SetNodeDraggable(Int32, Boolean)

##### Declaration

    public static void SetNodeDraggable(int node_id, bool draggable)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | node_id |
System.Boolean | draggable |

| Improve this Doc View Source

#### SetNodeEditorSpacePos(Int32, Vector2)

##### Declaration

    public static void SetNodeEditorSpacePos(int node_id, Vector2 editor_space_pos)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | node_id |
System.Numerics.Vector2 | editor_space_pos |

| Improve this Doc View Source

#### SetNodeGridSpacePos(Int32, Vector2)

##### Declaration

    public static void SetNodeGridSpacePos(int node_id, Vector2 grid_pos)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | node_id |
System.Numerics.Vector2 | grid_pos |

| Improve this Doc View Source

#### SetNodeScreenSpacePos(Int32, Vector2)

##### Declaration

    public static void SetNodeScreenSpacePos(int node_id, Vector2 screen_space_pos)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Int32 | node_id |
System.Numerics.Vector2 | screen_space_pos |

| Improve this Doc View Source

#### Shutdown()

##### Declaration

    public static void Shutdown()

| Improve this Doc View Source

#### StyleColorsClassic()

##### Declaration

    public static void StyleColorsClassic()

| Improve this Doc View Source

#### StyleColorsDark()

##### Declaration

    public static void StyleColorsDark()

| Improve this Doc View Source

#### StyleColorsLight()

##### Declaration

    public static void StyleColorsLight()